//
//  scViewController.m
//  sc
//
//  Created by xcc on 09/08/15.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "scViewController.h"
#import "testView.h"

@implementation scViewController



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
	[super loadView];

	scrollview = [[UIScrollView alloc] initWithFrame:self.view.bounds];
	[self.view addSubview:scrollview];
	testview = [[testView alloc] initWithFrame:CGRectMake(0, 0, 500, 500)];
	[scrollview addSubview:testview];
	[scrollview setContentSize:testview.frame.size];	//	スクロール範囲設定
	[scrollview setDelegate:self];			//	デリゲート設定
	[scrollview setMinimumZoomScale:0.5];	//	ズームアウト下限設定
	[scrollview setMaximumZoomScale:2.0];	//	ズームイン上限設定。
	scrollview.bounces = NO;				//	NOだとドラッグで範囲外までスクロールしてから戻るという動作を禁止する。
	scrollview.bouncesZoom = YES;			//	YESだとピンチで許可したズーム範囲外までズームを許してから範囲内に戻るという動作をゆるす。
	lastScale = 2.0;						//	scrollViewDidEndZoomingで利用。
	scrollview.zoomScale = lastScale;
	//	一緒にスクロールするが、ズームは連動しないボタンを配置。
	UIButton* button = [UIButton buttonWithType:UIButtonTypeInfoLight];
	button.frame = CGRectMake(10, 10, 20, 20);
	[scrollview addSubview:button];			//	ズームまで連動させたければ scrollview を testview に変更する。
}


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

/*
	この移譲メソッドでズーム対象のUIViewを返す事で、UIScrollViewはピンチジェスチャーに対応してくれる。
	ただし、setMinimumZoomScaleかsetMaximumZoomScaleで1.0以外を指定していないと意味が無い。
*/
- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView {
    UIView *view = nil;
    if (scrollView == scrollview) {
        view = testview;
    }
    return view;
}


- (void)scrollViewDidEndZooming:(UIScrollView *)scrollView withView:(UIView *)view atScale:(float)scale {
	//	以下の2行はzoomToRect:animated:メソッドの不具合対策。
    [scrollView setZoomScale:scale+0.01 animated:NO];
    [scrollView setZoomScale:scale animated:NO];

	//	以下でscaleが0.5、1.0、2.0のいずれかの値になるよう調整。
	if (scale > lastScale) {
		scale = lastScale * 2.0;
	} else if (scale < lastScale) {
		scale = lastScale / 2.0;
	}
	lastScale = scale;
    [scrollView setZoomScale:scale animated:YES];
	//	0.5倍表示の時は、画面中央にセンタリングする。
	if (scale < 1.0) {
		//	ステータスバーの高さを考慮するべきだが省略。また 500 x 500という値も変数等に持たせるのが適切。
		CGRect r = testview.frame;
		r.origin.x = ([UIScreen mainScreen].bounds.size.width - 500 * scale) / 2;
		r.origin.y = ([UIScreen mainScreen].bounds.size.height - 500 * scale) / 2;
		testview.frame = r;
	} else {
		CGRect r = testview.frame;
		r.origin.x = 0;
		r.origin.y = 0;
		testview.frame = r;
	}
}


@end
